From 698dfefdad8ad8f04d4bdc35204bd344e812f213 Mon Sep 17 00:00:00 2001
From: Simo Sorce <simo@redhat.com>
Date: Mon, 1 Feb 2016 07:35:17 -0500
Subject: [PATCH 11/15] Secrets: Add encryption at rest

Generates a master key file if it doesn't exist and encrypts secrets using the
master key contained in the file.

Resolves:
https://fedorahosted.org/sssd/ticket/XXXX
---
 Makefile.am                             |  14 +-
 po/ca.po                                | 690 ++++++++++++++++----------------
 src/responder/secrets/local.c           | 191 +++++++--
 src/responder/secrets/secsrv_local.h    |   2 +-
 src/util/crypto/libcrypto/crypto_nite.c | 226 +++++++++++
 src/util/crypto/nss/nss_crypto.h        |  67 ++++
 src/util/crypto/nss/nss_nite.c          | 245 ++++++++++++
 src/util/crypto/nss/nss_obfuscate.c     | 214 +---------
 src/util/crypto/nss/nss_util.c          | 211 +++++++++-
 src/util/crypto/nss/nss_util.h          |   1 +
 src/util/crypto/sss_crypto.c            |  66 +++
 src/util/crypto/sss_crypto.h            |  37 ++
 12 files changed, 1396 insertions(+), 568 deletions(-)
 create mode 100644 src/util/crypto/libcrypto/crypto_nite.c
 create mode 100644 src/util/crypto/nss/nss_crypto.h
 create mode 100644 src/util/crypto/nss/nss_nite.c
 create mode 100644 src/util/crypto/sss_crypto.c

diff --git a/Makefile.am b/Makefile.am
index fd9f493bedf319a0c38d224d8d7e1fc981f1a06d..1e1ebcef72e8a8eea1c079b6ee0faeb763131df4 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -692,7 +692,8 @@ dist_noinst_HEADERS = \
 
 
 if HAVE_NSS
-    dist_noinst_HEADERS += src/util/crypto/nss/nss_util.h
+    dist_noinst_HEADERS += src/util/crypto/nss/nss_util.h \
+                           src/util/crypto/nss/nss_crypto.h
 endif
 
 SSSD_DOCS = \
@@ -751,7 +752,10 @@ if HAVE_NSS
                         src/util/crypto/nss/nss_hmac_sha1.c \
                         src/util/crypto/nss/nss_sha512crypt.c \
                         src/util/crypto/nss/nss_obfuscate.c \
-                        src/util/crypto/nss/nss_util.c
+                        src/util/crypto/nss/nss_nite.c \
+                        src/util/crypto/nss/nss_util.c \
+			src/util/crypto/sss_crypto.c \
+			$(NULL)
     SSS_CRYPT_CFLAGS = $(NSS_CFLAGS)
     SSS_CRYPT_LIBS = $(NSS_LIBS)
 
@@ -769,7 +773,10 @@ else
     SSS_CRYPT_SOURCES = src/util/crypto/libcrypto/crypto_base64.c \
                         src/util/crypto/libcrypto/crypto_hmac_sha1.c \
                         src/util/crypto/libcrypto/crypto_sha512crypt.c \
-                        src/util/crypto/libcrypto/crypto_obfuscate.c
+                        src/util/crypto/libcrypto/crypto_obfuscate.c \
+                        src/util/crypto/libcrypto/crypto_nite.c \
+			src/util/crypto/sss_crypto.c \
+			$(NULL)
     SSS_CRYPT_CFLAGS = $(CRYPTO_CFLAGS)
     SSS_CRYPT_LIBS = $(CRYPTO_LIBS)
 
@@ -2653,6 +2660,7 @@ test_krb5_wait_queue_LDADD = \
 
 test_cert_utils_SOURCES = \
     src/tests/cmocka/test_cert_utils.c \
+    src/util/util.c \
     $(NULL)
 test_cert_utils_CFLAGS = \
     $(AM_CFLAGS) \
diff --git a/src/responder/secrets/local.c b/src/responder/secrets/local.c
index f8e3360b9dc8336b93e512514790c474de6c0b55..94e1fac43c2d58fd7e54e6041b289684ec77d588 100644
--- a/src/responder/secrets/local.c
+++ b/src/responder/secrets/local.c
@@ -20,9 +20,75 @@
 */
 
 #include "responder/secrets/secsrv_private.h"
+#include "util/crypto/sss_crypto.h"
 #include <ldb.h>
 
+#define MKEY_SIZE (256 / 8)
 
+struct local_context {
+    struct ldb_context *ldb;
+    struct sec_data master_key;
+};
+
+int local_decrypt(struct local_context *lctx, TALLOC_CTX *mem_ctx,
+                  const char *secret, const char *enctype,
+                  char **plain_secret)
+{
+    char *output;
+
+    if (enctype && strcmp(enctype, "masterkey") == 0) {
+        struct sec_data _secret;
+        size_t outlen;
+        int ret;
+
+        _secret.data = (char *)sss_base64_decode(mem_ctx, secret,
+                                                 &_secret.length);
+        if (!_secret.data) return EINVAL;
+
+        ret = sss_decrypt(mem_ctx, AES256CBC_HMAC_SHA256,
+                          (uint8_t *)lctx->master_key.data,
+                          lctx->master_key.length,
+                          (uint8_t *)_secret.data, _secret.length,
+                          (uint8_t **)&output, &outlen);
+        if (ret) return ret;
+
+        if (((strnlen(output, outlen) + 1) != outlen) ||
+            output[outlen - 1] != '\0') {
+            return EIO;
+        }
+    } else {
+        output = talloc_strdup(mem_ctx, secret);
+        if (!output) return ENOMEM;
+    }
+
+    *plain_secret = output;
+    return EOK;
+}
+
+int local_encrypt(struct local_context *lctx, TALLOC_CTX *mem_ctx,
+                  const char *secret, const char *enctype,
+                  char **ciphertext)
+{
+    struct sec_data _secret;
+    char *output;
+    int ret;
+
+    if (!enctype || strcmp(enctype, "masterkey") != 0) return EINVAL;
+
+    ret = sss_encrypt(mem_ctx, AES256CBC_HMAC_SHA256,
+                      (uint8_t *)lctx->master_key.data,
+                      lctx->master_key.length,
+                      (const uint8_t *)secret, strlen(secret) + 1,
+                      (uint8_t **)&_secret.data, &_secret.length);
+    if (ret) return ret;
+
+    output = sss_base64_encode(mem_ctx,
+                               (uint8_t *)_secret.data, _secret.length);
+    if (!output) return ENOMEM;
+
+    *ciphertext = output;
+    return EOK;
+}
 
 int local_db_dn(TALLOC_CTX *mem_ctx,
                 struct ldb_context *ldb,
@@ -101,25 +167,26 @@ char *local_dn_to_path(TALLOC_CTX *mem_ctx,
 }
 
 int local_db_get_simple(TALLOC_CTX *mem_ctx,
-                        struct ldb_context *ldb,
+                        struct local_context *lctx,
                         const char *req_path,
                         char **secret)
 {
     TALLOC_CTX *tmp_ctx;
-    static const char *attrs[] = { "secret", NULL };
+    static const char *attrs[] = { "secret", "enctype", NULL };
     const char *filter = "(type=simple)";
     struct ldb_result *res;
     struct ldb_dn *dn;
     const char *attr_secret;
+    const char *attr_enctype;
     int ret;
 
     tmp_ctx = talloc_new(mem_ctx);
     if (!tmp_ctx) return ENOMEM;
 
-    ret = local_db_dn(tmp_ctx, ldb, req_path, &dn);
+    ret = local_db_dn(tmp_ctx, lctx->ldb, req_path, &dn);
     if (ret != EOK) goto done;
 
-    ret = ldb_search(ldb, tmp_ctx, &res, dn, LDB_SCOPE_BASE,
+    ret = ldb_search(lctx->ldb, tmp_ctx, &res, dn, LDB_SCOPE_BASE,
                      attrs, filter);
     if (ret != EOK) {
         ret = ENOENT;
@@ -143,7 +210,14 @@ int local_db_get_simple(TALLOC_CTX *mem_ctx,
         goto done;
     }
 
-    *secret = talloc_strdup(mem_ctx, attr_secret);
+    attr_enctype = ldb_msg_find_attr_as_string(res->msgs[0], "enctype", NULL);
+
+    if (attr_enctype) {
+        ret = local_decrypt(lctx, mem_ctx, attr_secret, attr_enctype, secret);
+        if (ret) goto done;
+    } else {
+        *secret = talloc_strdup(mem_ctx, attr_secret);
+    }
     ret = EOK;
 
 done:
@@ -152,7 +226,7 @@ done:
 }
 
 int local_db_list_keys(TALLOC_CTX *mem_ctx,
-                       struct ldb_context *ldb,
+                       struct local_context *lctx,
                        const char *req_path,
                        char ***_keys,
                        int *num_keys)
@@ -168,10 +242,10 @@ int local_db_list_keys(TALLOC_CTX *mem_ctx,
     tmp_ctx = talloc_new(mem_ctx);
     if (!tmp_ctx) return ENOMEM;
 
-    ret = local_db_dn(tmp_ctx, ldb, req_path, &dn);
+    ret = local_db_dn(tmp_ctx, lctx->ldb, req_path, &dn);
     if (ret != EOK) goto done;
 
-    ret = ldb_search(ldb, tmp_ctx, &res, dn, LDB_SCOPE_SUBTREE,
+    ret = ldb_search(lctx->ldb, tmp_ctx, &res, dn, LDB_SCOPE_SUBTREE,
                      attrs, filter);
     if (ret != EOK) {
         ret = ENOENT;
@@ -207,11 +281,13 @@ done:
 }
 
 int local_db_put_simple(TALLOC_CTX *mem_ctx,
-                        struct ldb_context *ldb,
+                        struct local_context *lctx,
                         const char *req_path,
                         const char *secret)
 {
     struct ldb_message *msg;
+    const char *enctype = "masterkey";
+    char *enc_secret;
     int ret;
 
     msg = ldb_msg_new(mem_ctx);
@@ -220,16 +296,24 @@ int local_db_put_simple(TALLOC_CTX *mem_ctx,
         goto done;
     }
 
-    ret = local_db_dn(msg, ldb, req_path, &msg->dn);
+    /* FIXME: verify containers (except for user's namespace) exists */
+
+    ret = local_encrypt(lctx, msg, secret, enctype, &enc_secret);
+    if (ret != EOK) goto done;
+
+    ret = local_db_dn(msg, lctx->ldb, req_path, &msg->dn);
     if (ret != EOK) goto done;
 
     ret = ldb_msg_add_string(msg, "type", "simple");
     if (ret != EOK) goto done;
 
-    ret = ldb_msg_add_string(msg, "secret", secret);
+    ret = ldb_msg_add_string(msg, "enctype", enctype);
     if (ret != EOK) goto done;
 
-    ret = ldb_add(ldb, msg);
+    ret = ldb_msg_add_string(msg, "secret", enc_secret);
+    if (ret != EOK) goto done;
+
+    ret = ldb_add(lctx->ldb, msg);
     if (ret != EOK) {
         if (ret == LDB_ERR_ENTRY_ALREADY_EXISTS) ret = EEXIST;
         else ret = EIO;
@@ -244,16 +328,16 @@ done:
 }
 
 int local_db_delete(TALLOC_CTX *mem_ctx,
-                    struct ldb_context *ldb,
+                    struct local_context *lctx,
                     const char *req_path)
 {
     struct ldb_dn *dn;
     int ret;
 
-    ret = local_db_dn(mem_ctx, ldb, req_path, &dn);
+    ret = local_db_dn(mem_ctx, lctx->ldb, req_path, &dn);
     if (ret != EOK) goto done;
 
-    ret = ldb_delete(ldb, dn);
+    ret = ldb_delete(lctx->ldb, dn);
     if (ret != EOK) {
         ret = EIO;
     }
@@ -319,7 +403,7 @@ struct tevent_req *local_secret_req(TALLOC_CTX *mem_ctx,
 {
     struct tevent_req *req;
     struct local_secret_state *state;
-    struct ldb_context *ldb;
+    struct local_context *lctx;
     struct sec_data body = { 0 };
     char *req_path;
     char *secret;
@@ -333,8 +417,8 @@ struct tevent_req *local_secret_req(TALLOC_CTX *mem_ctx,
     state->ev = ev;
     state->secreq = secreq;
 
-    ldb = talloc_get_type(provider_ctx, struct ldb_context);
-    if (!ldb) {
+    lctx = talloc_get_type(provider_ctx, struct local_context);
+    if (!lctx) {
         ret = EIO;
         goto done;
     }
@@ -345,13 +429,13 @@ struct tevent_req *local_secret_req(TALLOC_CTX *mem_ctx,
     switch (secreq->method) {
     case HTTP_GET:
         if (req_path[strlen(req_path) - 1] == '/') {
-            ret = local_db_list_keys(state, ldb, req_path, &keys, &nkeys);
+            ret = local_db_list_keys(state, lctx, req_path, &keys, &nkeys);
             if (ret) goto done;
 
             ret = sec_array_to_json(state, keys, nkeys, &body.data);
             if (ret) goto done;
         } else {
-            ret = local_db_get_simple(state, ldb, req_path, &secret);
+            ret = local_db_get_simple(state, lctx, req_path, &secret);
             if (ret) goto done;
 
             ret = sec_simple_secret_to_json(state, secret, &body.data);
@@ -362,15 +446,17 @@ struct tevent_req *local_secret_req(TALLOC_CTX *mem_ctx,
         break;
 
     case HTTP_PUT:
+        /*FIXME: check fot content-type */
+
         ret = sec_json_to_simple_secret(state, secreq->body.data, &secret);
         if (ret) goto done;
 
-        ret = local_db_put_simple(state, ldb, req_path, secret);
+        ret = local_db_put_simple(state, lctx, req_path, secret);
         if (ret) goto done;
         break;
 
     case HTTP_DELETE:
-        ret = local_db_delete(state, ldb, req_path);
+        ret = local_db_delete(state, lctx, req_path);
         if (ret) goto done;
         break;
 
@@ -397,6 +483,29 @@ done:
     return tevent_req_post(req, state->ev);
 }
 
+int generate_master_key(const char *filename, size_t size)
+{
+    uint8_t buf[size];
+    ssize_t rsize;
+    int ret;
+    int fd;
+
+    ret = generate_csprng_buffer(buf, size);
+    if (ret) return ret;
+
+    fd = open(filename, O_CREAT|O_EXCL|O_WRONLY, 0600);
+    if (fd == -1) return errno;
+
+    rsize = sss_atomic_io_s(fd, buf, size, false);
+    close(fd);
+    if (rsize != size) {
+        unlink(filename);
+        return EFAULT;
+    }
+
+    return EOK;
+}
+
 /* FIXME: allocate on the responder context */
 static struct provider_handle local_secrets_handle = {
     .fn = local_secret_req,
@@ -406,20 +515,46 @@ static struct provider_handle local_secrets_handle = {
 int local_secrets_provider_handle(TALLOC_CTX *mem_ctx,
                                   struct provider_handle **handle)
 {
-    struct ldb_context *ldb;
+    struct local_context *lctx;
     int ret;
 
     if (local_secrets_handle.context == NULL) {
-        ldb = ldb_init(NULL, NULL);
-        if (!ldb) return EIO;
+        const char *mkey = SECRETS_DB_PATH"/.secrets.mkey";
+        ssize_t size;
+        int mfd;
 
-        ret = ldb_connect(ldb, SECRETS_DB_PATH"/secrets.ldb", 0, NULL);
+        lctx = talloc_zero(NULL, struct local_context);
+        if (!lctx) return ENOMEM;
+
+        lctx->ldb = ldb_init(lctx, NULL);
+        if (!lctx->ldb) return ENOMEM;
+
+        ret = ldb_connect(lctx->ldb, SECRETS_DB_PATH"/secrets.ldb", 0, NULL);
         if (ret != LDB_SUCCESS) {
-            talloc_free(ldb);
+            talloc_free(lctx->ldb);
             return EIO;
         }
 
-        local_secrets_handle.context = ldb;
+        lctx->master_key.data = talloc_size(lctx, MKEY_SIZE);
+        if (!lctx->master_key.data) return ENOMEM;
+        lctx->master_key.length = MKEY_SIZE;
+
+        ret = check_and_open_readonly(mkey, &mfd, 0, 0,
+                                      S_IFREG|S_IRUSR|S_IWUSR, 0);
+        if (ret == ENOENT) {
+            ret = generate_master_key(mkey, MKEY_SIZE);
+            if (ret) return EFAULT;
+            ret = check_and_open_readonly(mkey, &mfd, 0, 0,
+                                          S_IFREG|S_IRUSR|S_IWUSR, 0);
+        }
+        if (ret) return EFAULT;
+
+        size = sss_atomic_io_s(mfd, lctx->master_key.data,
+                               lctx->master_key.length, true);
+        close(mfd);
+        if (size < 0 || size != lctx->master_key.length) return EIO;
+
+        local_secrets_handle.context = lctx;
     }
 
     *handle = &local_secrets_handle;
diff --git a/src/responder/secrets/secsrv_local.h b/src/responder/secrets/secsrv_local.h
index 537f61e53d098deecbc2530e9e3c21a07eaecada..d21b14953b0497a17f7b0b7730a3e1529f928aea 100644
--- a/src/responder/secrets/secsrv_local.h
+++ b/src/responder/secrets/secsrv_local.h
@@ -1,7 +1,7 @@
 /*
    SSSD
 
-   Secrets Local Provider
+   Secrets Proxy Provider
 
    Copyright (C) Simo Sorce <ssorce@redhat.com>	2016
 
diff --git a/src/util/crypto/libcrypto/crypto_nite.c b/src/util/crypto/libcrypto/crypto_nite.c
new file mode 100644
index 0000000000000000000000000000000000000000..f0660da389e8f140ed645364a0abdd977331b8d7
--- /dev/null
+++ b/src/util/crypto/libcrypto/crypto_nite.c
@@ -0,0 +1,226 @@
+/*
+   SSSD
+
+   Encryption/Decryption primitives
+
+   Authors:
+       Simo Sorce <simo@redhat.com>
+
+   Copyright (C) Simo Sorce 2016
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "config.h"
+#include <talloc.h>
+#include <errno.h>
+
+#include "util/util.h"
+#include "util/crypto/sss_crypto.h"
+
+#include <openssl/evp.h>
+#include <openssl/rand.h>
+#include <openssl/crypto.h>
+
+struct cipher_mech {
+    const EVP_CIPHER * (*cipher)(void);
+    const EVP_MD * (*digest)(void);
+} mechs[] = {
+    { EVP_aes_256_cbc, EVP_sha256 }
+};
+
+#define GOTO_IF_NOT_EQUAL(res, exp, ret, err, label) \
+    if (res != exp) { ret = err; goto label; }
+
+int sss_encrypt(TALLOC_CTX *mem_ctx, enum encmethod enctype,
+                uint8_t *key, size_t keylen,
+                const uint8_t *plaintext, size_t plainlen,
+                uint8_t **ciphertext, size_t *cipherlen)
+{
+    const EVP_CIPHER *cipher;
+    const EVP_MD *digest;
+    EVP_PKEY *hmackey;
+    EVP_CIPHER_CTX ctx;
+    EVP_MD_CTX mdctx;
+    uint8_t *out = NULL;
+    int evpkeylen;
+    int evpivlen;
+    int hmaclen;
+    int outlen, tmplen;
+    size_t slen;
+    int ret;
+
+    if (!plaintext || !plainlen) return EINVAL;
+
+    if (enctype != AES256CBC_HMAC_SHA256) return EINVAL;
+    cipher = mechs[AES256CBC_HMAC_SHA256].cipher();
+    digest = mechs[AES256CBC_HMAC_SHA256].digest();
+
+    evpkeylen = EVP_CIPHER_key_length(cipher);
+    if (!key || keylen != evpkeylen) return EINVAL;
+
+    hmackey = EVP_PKEY_new_mac_key(EVP_PKEY_HMAC, NULL, key, keylen);
+    if (!hmackey) return ENOMEM;
+
+    /* We have no function to return the size of the output for arbitray HMAC
+     * algorithms so we just truncate to the key size should the hmac be bigger
+     * (or pad with zeros should the HMAC be smaller) */
+    hmaclen = keylen;
+
+    evpivlen = EVP_CIPHER_iv_length(cipher);
+    outlen = plainlen + (2 * EVP_CIPHER_block_size(cipher))
+                + evpivlen + hmaclen;
+    out = talloc_zero_size(mem_ctx, outlen);
+
+    /* First Encrypt */
+
+    if (evpivlen != 0) {
+        RAND_bytes(out, evpivlen);
+    }
+
+    EVP_CIPHER_CTX_init(&ctx);
+    ret = EVP_EncryptInit_ex(&ctx, cipher, 0, key, evpivlen ? out : NULL);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    outlen = evpivlen;
+    tmplen = 0;
+    ret = EVP_EncryptUpdate(&ctx, out + outlen, &tmplen, plaintext, plainlen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    outlen += tmplen;
+
+    ret = EVP_EncryptFinal_ex(&ctx, out + outlen, &tmplen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    outlen += tmplen;
+
+    /* Then HMAC */
+
+    EVP_MD_CTX_init(&mdctx);
+
+    ret = EVP_DigestInit_ex(&mdctx, digest, NULL);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = EVP_DigestSignInit(&mdctx, NULL, digest, NULL, hmackey);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = EVP_DigestSignUpdate(&mdctx, out, outlen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    slen = hmaclen;
+    ret = EVP_DigestSignFinal(&mdctx, &out[outlen], &slen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    outlen += hmaclen;
+
+    *ciphertext = out;
+    *cipherlen = outlen;
+    ret = EOK;
+
+done:
+    EVP_MD_CTX_cleanup(&mdctx);
+    EVP_CIPHER_CTX_cleanup(&ctx);
+    EVP_PKEY_free(hmackey);
+    return ret;
+}
+
+int sss_decrypt(TALLOC_CTX *mem_ctx, enum encmethod enctype,
+                uint8_t *key, size_t keylen,
+                const uint8_t *ciphertext, size_t cipherlen,
+                uint8_t **plaintext, size_t *plainlen)
+{
+    const EVP_CIPHER *cipher;
+    const EVP_MD *digest;
+    EVP_PKEY *hmackey;
+    EVP_CIPHER_CTX ctx;
+    EVP_MD_CTX mdctx;
+    const uint8_t *iv = NULL;
+    uint8_t *out;
+    int evpkeylen;
+    int evpivlen;
+    int hmaclen;
+    int outlen, tmplen;
+    size_t slen;
+    int ret;
+
+    if (!ciphertext || !cipherlen) return EINVAL;
+
+    if (enctype != AES256CBC_HMAC_SHA256) return EINVAL;
+    cipher = mechs[AES256CBC_HMAC_SHA256].cipher();
+    digest = mechs[AES256CBC_HMAC_SHA256].digest();
+
+    evpkeylen = EVP_CIPHER_key_length(cipher);
+    if (!key || keylen != evpkeylen) return EINVAL;
+
+    hmackey = EVP_PKEY_new_mac_key(EVP_PKEY_HMAC, NULL, key, keylen);
+    if (!hmackey) return ENOMEM;
+
+    /* We have no function to return the size of the output for arbitray HMAC
+     * algorithms so we just assume it was truncated to the key size should
+     * the hmac be bigger (or pad with zeros should the HMAC be smaller) */
+    hmaclen = keylen;
+
+    evpivlen = EVP_CIPHER_iv_length(cipher);
+    out = talloc_zero_size(mem_ctx, cipherlen);
+
+    /* First check HMAC */
+
+    EVP_MD_CTX_init(&mdctx);
+
+    ret = EVP_DigestInit_ex(&mdctx, digest, NULL);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = EVP_DigestSignInit(&mdctx, NULL, digest, NULL, hmackey);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = EVP_DigestSignUpdate(&mdctx, ciphertext, cipherlen - hmaclen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    slen = hmaclen;
+    ret = EVP_DigestSignFinal(&mdctx, out, &slen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = CRYPTO_memcmp(&ciphertext[cipherlen - hmaclen], out, hmaclen);
+    GOTO_IF_NOT_EQUAL(ret, 0, ret, EFAULT, done);
+
+    /* Then Decrypt */
+
+    if (evpivlen != 0) {
+        iv = ciphertext;
+    }
+
+    EVP_CIPHER_CTX_init(&ctx);
+    ret = EVP_DecryptInit_ex(&ctx, cipher, 0, key, iv);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = EVP_DecryptUpdate(&ctx, out, &outlen,
+                            ciphertext + evpivlen,
+                            cipherlen - evpivlen - hmaclen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    ret = EVP_DecryptFinal_ex(&ctx, out + outlen, &tmplen);
+    GOTO_IF_NOT_EQUAL(ret, 1, ret, EFAULT, done);
+
+    outlen += tmplen;
+
+    *plaintext = out;
+    *plainlen = outlen;
+    ret = EOK;
+
+done:
+    EVP_MD_CTX_cleanup(&mdctx);
+    EVP_CIPHER_CTX_cleanup(&ctx);
+    EVP_PKEY_free(hmackey);
+    return ret;
+}
diff --git a/src/util/crypto/nss/nss_crypto.h b/src/util/crypto/nss/nss_crypto.h
new file mode 100644
index 0000000000000000000000000000000000000000..c6c0ea8e7fc78bbe9378abdcccf2ffd00278f732
--- /dev/null
+++ b/src/util/crypto/nss/nss_crypto.h
@@ -0,0 +1,67 @@
+/*
+   SSSD
+
+   NSS crypto wrappers
+
+   Authors:
+        Jakub Hrozek <jhrozek@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2010
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <nss.h>
+#include <prerror.h>
+#include <pk11func.h>
+#include <base64.h>
+#include <talloc.h>
+
+#define MAKE_SECITEM(sdata, slen, sitem) do { \
+    (sitem)->type = (siBuffer); \
+    (sitem)->data = (sdata);    \
+    (sitem)->len  = (slen);     \
+} while(0)
+
+struct sss_nss_crypto_ctx {
+    PK11SlotInfo *slot;
+    PK11Context  *ectx;
+    PK11SymKey   *keyobj;
+    SECItem      *sparam;
+
+    SECItem      *iv;
+    SECItem      *key;
+};
+
+struct crypto_mech_data {
+    CK_MECHANISM_TYPE cipher;
+    uint16_t keylen;
+    uint16_t bsize;
+};
+
+enum crypto_mech_op {
+    op_encrypt,
+    op_decrypt,
+    op_sign
+};
+
+int nss_ctx_init(TALLOC_CTX *mem_ctx,
+                 struct crypto_mech_data *mech_props,
+                 uint8_t *key, int keylen,
+                 uint8_t *iv, int ivlen,
+                 struct sss_nss_crypto_ctx **_cctx);
+int nss_crypto_init(struct crypto_mech_data *mech_props,
+                    enum crypto_mech_op crypto_op,
+                    struct sss_nss_crypto_ctx *cctx);
+
diff --git a/src/util/crypto/nss/nss_nite.c b/src/util/crypto/nss/nss_nite.c
new file mode 100644
index 0000000000000000000000000000000000000000..7ebdbac4a23a9c8d830d24782ca4906c3ef7cc98
--- /dev/null
+++ b/src/util/crypto/nss/nss_nite.c
@@ -0,0 +1,245 @@
+/*
+   SSSD
+
+   Encryption/Decryption primitives
+
+   Authors:
+       Simo Sorce <simo@redhat.com>
+
+   Copyright (C) Simo Sorce 2016
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "config.h"
+
+#include "util/util.h"
+#include "util/crypto/sss_crypto.h"
+#include "util/crypto/nss/nss_util.h"
+#include "util/crypto/nss/nss_crypto.h"
+
+struct cipher_mech {
+    struct crypto_mech_data enc;
+    struct crypto_mech_data hmac;
+} mechs[] = {
+    { { CKM_AES_CBC_PAD, 32, 16 }, { CKM_SHA256_HMAC, 32, 16 } }
+};
+
+#define GOTO_IF_NOT_EQUAL(res, exp, ret, err, label) \
+    if (res != exp) { ret = err; goto label; }
+
+int sss_encrypt(TALLOC_CTX *mem_ctx, enum encmethod enctype,
+                uint8_t *key, size_t keylen,
+                const uint8_t *plaintext, size_t plainlen,
+                uint8_t **ciphertext, size_t *cipherlen)
+{
+    TALLOC_CTX *tmp_ctx = NULL;
+    struct sss_nss_crypto_ctx *cctx;
+    struct sss_nss_crypto_ctx *hctx;
+    struct crypto_mech_data *enc;
+    struct crypto_mech_data *hmac;
+    SECStatus sret;
+    uint8_t *out = NULL;
+    int ivlen;
+    int hmaclen;
+    int outlen;
+    int clen;
+    union {
+        unsigned int u;
+        int s;
+    } tmplen;
+    unsigned int digestlen;
+    int ret;
+
+    if (!plaintext || !plainlen) return EINVAL;
+
+    if (enctype != AES256CBC_HMAC_SHA256) return EINVAL;
+    enc = &mechs[AES256CBC_HMAC_SHA256].enc;
+    hmac = &mechs[AES256CBC_HMAC_SHA256].hmac;
+    ivlen = enc->bsize;
+
+    /* We have no function to return the size of the output for arbitray HMAC
+     * algorithms so we just truncate to the key size should the hmac be bigger
+     * (or pad with zeros should the HMAC be smaller) */
+    hmaclen = keylen;
+
+    tmp_ctx = talloc_new(mem_ctx);
+    if (!tmp_ctx) {
+        return ENOMEM;
+    }
+
+    /* initialize NSS if needed */
+    ret = nspr_nss_init();
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    outlen = plainlen + (2 * enc->bsize) + ivlen + hmaclen;
+    out = talloc_zero_size(tmp_ctx, outlen);
+
+    /* First Encrypt */
+
+    if (ivlen != 0) {
+        ret = generate_csprng_buffer(out, ivlen);
+        if (ret) return ret;
+    }
+
+    ret = nss_ctx_init(tmp_ctx, enc, key, keylen, out, ivlen, &cctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    ret = nss_crypto_init(enc, op_encrypt, cctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    clen = ivlen;
+
+    sret = PK11_CipherOp(cctx->ectx, out + clen, &tmplen.s,
+                         outlen - clen, plaintext, plainlen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    clen += tmplen.s;
+
+    sret = PK11_DigestFinal(cctx->ectx, out + clen, &tmplen.u, outlen - clen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    clen += tmplen.u;
+    if (clen < 0 || clen > UINT16_MAX) {
+        ret = ERANGE;
+        goto done;
+    }
+
+    /* Then HMAC */
+
+    ret = nss_ctx_init(tmp_ctx, hmac, key, keylen, NULL, 0, &hctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    ret = nss_crypto_init(hmac, op_sign, hctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    sret = PK11_DigestBegin(hctx->ectx);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    sret = PK11_DigestOp(hctx->ectx, out, clen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    sret = PK11_DigestFinal(hctx->ectx, out + clen, &digestlen,
+                            outlen - clen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    *ciphertext = talloc_move(mem_ctx, &out);
+    *cipherlen = clen + hmaclen;
+    ret = EOK;
+
+done:
+    talloc_free(tmp_ctx);
+    nspr_nss_cleanup();
+    return ret;
+}
+
+int sss_decrypt(TALLOC_CTX *mem_ctx, enum encmethod enctype,
+                uint8_t *key, size_t keylen,
+                const uint8_t *ciphertext, size_t cipherlen,
+                uint8_t **plaintext, size_t *plainlen)
+{
+    TALLOC_CTX *tmp_ctx = NULL;
+    struct sss_nss_crypto_ctx *cctx;
+    struct sss_nss_crypto_ctx *hctx;
+    struct crypto_mech_data *enc;
+    struct crypto_mech_data *hmac;
+    SECStatus sret;
+    uint8_t *out = NULL;
+    uint8_t *ivbuf = NULL;
+    int ivlen;
+    int hmaclen;
+    int outlen;
+    unsigned int tmplen;
+    unsigned int digestlen;
+    int ret;
+
+    if (!plaintext || !plainlen) return EINVAL;
+
+    if (enctype != AES256CBC_HMAC_SHA256) return EINVAL;
+    enc = &mechs[AES256CBC_HMAC_SHA256].enc;
+    hmac = &mechs[AES256CBC_HMAC_SHA256].hmac;
+    ivlen = enc->bsize;
+
+    /* We have no function to return the size of the output for arbitray HMAC
+     * algorithms so we just truncate to the key size should the hmac be bigger
+     * (or pad with zeros should the HMAC be smaller) */
+    hmaclen = keylen;
+
+    tmp_ctx = talloc_new(mem_ctx);
+    if (!tmp_ctx) {
+        return ENOMEM;
+    }
+
+    /* initialize NSS if needed */
+    ret = nspr_nss_init();
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    out = talloc_zero_size(tmp_ctx, cipherlen);
+
+    /* First check HMAC */
+
+    ret = nss_ctx_init(tmp_ctx, hmac, key, keylen, NULL, 0, &hctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    ret = nss_crypto_init(hmac, op_sign, hctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    sret = PK11_DigestBegin(hctx->ectx);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    sret = PK11_DigestOp(hctx->ectx, ciphertext, cipherlen - hmaclen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    sret = PK11_DigestFinal(hctx->ectx, out, &digestlen, hmaclen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    ret = NSS_SecureMemcmp(&ciphertext[cipherlen - hmaclen], out, hmaclen);
+    GOTO_IF_NOT_EQUAL(ret, 0, ret, EFAULT, done);
+
+    /* Then Decrypt */
+
+    if (ivlen != 0) {
+        ivbuf = talloc_size(tmp_ctx, ivlen);
+        if (!ivbuf) {
+            ret = ENOMEM;
+            goto done;
+        }
+        memcpy(ivbuf, ciphertext, ivlen);
+    }
+
+    ret = nss_ctx_init(tmp_ctx, enc, key, keylen, ivbuf, ivlen, &cctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    ret = nss_crypto_init(enc, op_decrypt, cctx);
+    GOTO_IF_NOT_EQUAL(ret, EOK, ret, EFAULT, done);
+
+    sret = PK11_CipherOp(cctx->ectx, out, &outlen, cipherlen,
+                         ciphertext + ivlen, cipherlen - ivlen - hmaclen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    sret = PK11_DigestFinal(cctx->ectx, out + outlen, &tmplen,
+                            cipherlen - outlen);
+    GOTO_IF_NOT_EQUAL(sret, SECSuccess, ret, EFAULT, done);
+
+    outlen += tmplen;
+
+    *plaintext = talloc_move(mem_ctx, &out);
+    *plainlen = outlen;
+    ret = EOK;
+
+done:
+    talloc_free(tmp_ctx);
+    nspr_nss_cleanup();
+    return ret;
+}
